/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "sxfs"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "sxfs"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *full_help_help; /**< @brief Print help, including hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * tempdir_arg;	/**< @brief Set sxfs temporary directory.  */
  char * tempdir_orig;	/**< @brief Set sxfs temporary directory original value given at command line.  */
  const char *tempdir_help; /**< @brief Set sxfs temporary directory help description.  */
  char * recovery_dir_arg;	/**< @brief Set directory for files that could not be uploaded (if not specified tempdir with \"-lost\" suffix will be used).  */
  char * recovery_dir_orig;	/**< @brief Set directory for files that could not be uploaded (if not specified tempdir with \"-lost\" suffix will be used) original value given at command line.  */
  const char *recovery_dir_help; /**< @brief Set directory for files that could not be uploaded (if not specified tempdir with \"-lost\" suffix will be used) help description.  */
  char * logfile_arg;	/**< @brief Set sxfs logfile.  */
  char * logfile_orig;	/**< @brief Set sxfs logfile original value given at command line.  */
  const char *logfile_help; /**< @brief Set sxfs logfile help description.  */
  char ** mount_options_arg;	/**< @brief Mount options.  */
  char ** mount_options_orig;	/**< @brief Mount options original value given at command line.  */
  unsigned int mount_options_min; /**< @brief Mount options's minimum occurreces */
  unsigned int mount_options_max; /**< @brief Mount options's maximum occurreces */
  const char *mount_options_help; /**< @brief Mount options help description.  */
  int use_queues_flag;	/**< @brief Enable queues for upload and delete operations (default=off).  */
  const char *use_queues_help; /**< @brief Enable queues for upload and delete operations help description.  */
  char * cache_size_arg;	/**< @brief Set size for local cache (default='512M').  */
  char * cache_size_orig;	/**< @brief Set size for local cache original value given at command line.  */
  const char *cache_size_help; /**< @brief Set size for local cache help description.  */
  char * cache_dir_arg;	/**< @brief Set directory for cache (sxfs tempdir by default).  */
  char * cache_dir_orig;	/**< @brief Set directory for cache (sxfs tempdir by default) original value given at command line.  */
  const char *cache_dir_help; /**< @brief Set directory for cache (sxfs tempdir by default) help description.  */
  int replica_wait_flag;	/**< @brief Wait for full data replication on the cluster (default=off).  */
  const char *replica_wait_help; /**< @brief Wait for full data replication on the cluster help description.  */
  int foreground_flag;	/**< @brief Run in foreground (default=off).  */
  const char *foreground_help; /**< @brief Run in foreground help description.  */
  int debug_flag;	/**< @brief Enable debug messages (default=off).  */
  const char *debug_help; /**< @brief Enable debug messages help description.  */
  int verbose_flag;	/**< @brief Log more information about read/write operations (enables debug mode) (default=off).  */
  const char *verbose_help; /**< @brief Log more information about read/write operations (enables debug mode) help description.  */
  int sx_debug_flag;	/**< @brief Enable SX debug mode (enables running in foreground) (default=off).  */
  const char *sx_debug_help; /**< @brief Enable SX debug mode (enables running in foreground) help description.  */
  int open_limit_arg;	/**< @brief Set open files limit (default='1024').  */
  char * open_limit_orig;	/**< @brief Set open files limit original value given at command line.  */
  const char *open_limit_help; /**< @brief Set open files limit help description.  */
  int fuse_help_flag;	/**< @brief Show FUSE help (default=off).  */
  const char *fuse_help_help; /**< @brief Show FUSE help help description.  */
  int fuse_version_flag;	/**< @brief Show FUSE version (default=off).  */
  const char *fuse_version_help; /**< @brief Show FUSE version help description.  */
  int fuse_single_threaded_flag;	/**< @brief Disable FUSE multi-threaded operation (default=off).  */
  const char *fuse_single_threaded_help; /**< @brief Disable FUSE multi-threaded operation help description.  */
  int fuse_debug_flag;	/**< @brief Run FUSE debug mode (default=off).  */
  const char *fuse_debug_help; /**< @brief Run FUSE debug mode help description.  */
  char * config_dir_arg;	/**< @brief Path to SX configuration directory.  */
  char * config_dir_orig;	/**< @brief Path to SX configuration directory original value given at command line.  */
  const char *config_dir_help; /**< @brief Path to SX configuration directory help description.  */
  char * filter_dir_arg;	/**< @brief Path to SX filter directory.  */
  char * filter_dir_orig;	/**< @brief Path to SX filter directory original value given at command line.  */
  const char *filter_dir_help; /**< @brief Path to SX filter directory help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int full_help_given ;	/**< @brief Whether full-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int tempdir_given ;	/**< @brief Whether tempdir was given.  */
  unsigned int recovery_dir_given ;	/**< @brief Whether recovery-dir was given.  */
  unsigned int logfile_given ;	/**< @brief Whether logfile was given.  */
  unsigned int mount_options_given ;	/**< @brief Whether mount-options was given.  */
  unsigned int use_queues_given ;	/**< @brief Whether use-queues was given.  */
  unsigned int cache_size_given ;	/**< @brief Whether cache-size was given.  */
  unsigned int cache_dir_given ;	/**< @brief Whether cache-dir was given.  */
  unsigned int replica_wait_given ;	/**< @brief Whether replica-wait was given.  */
  unsigned int foreground_given ;	/**< @brief Whether foreground was given.  */
  unsigned int debug_given ;	/**< @brief Whether debug was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int sx_debug_given ;	/**< @brief Whether sx-debug was given.  */
  unsigned int open_limit_given ;	/**< @brief Whether open-limit was given.  */
  unsigned int fuse_help_given ;	/**< @brief Whether fuse-help was given.  */
  unsigned int fuse_version_given ;	/**< @brief Whether fuse-version was given.  */
  unsigned int fuse_single_threaded_given ;	/**< @brief Whether fuse-single-threaded was given.  */
  unsigned int fuse_debug_given ;	/**< @brief Whether fuse-debug was given.  */
  unsigned int config_dir_given ;	/**< @brief Whether config-dir was given.  */
  unsigned int filter_dir_given ;	/**< @brief Whether filter-dir was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];
/** @brief all the lines making the full help output (including hidden options) */
extern const char *gengetopt_args_info_full_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the full help (including hidden options)
 */
void cmdline_parser_print_full_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
